/*  	Sql2FileTest.java
 *	
 *     Created on: Mar 22, 2004
 *     Created by: Dennis Groenendijk
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that
 * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
/* @#History
 * [When]		[Who]					[What]
 * 10-01-2005 dennis@brains2b.nl		Added test for trim option		
 */
package test.org.brains2b.sql.toclass;

import java.io.File;

import org.brains2b.sql.meta.ColumnModel;
import org.brains2b.sql.toclass.Sql2File;

/** Unit test for org.brains2b.sql.toclass.Sql2File
  * 
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version 0.11 [Jan 10, 2005]
 * @see org.brains2b.sql.toclass.Sql2File
 */
public class Sql2FileTest extends TestSql2Class {
    
	public void testSetTableModel() {
		Sql2File file=new Sql2File(new File(System.getProperty("java.io.tmpdir")),"sql2class.sql2file");
		file.setTableModel(tm);
		file.run();
		comparefiles(new File("test/sql2file/Course01.java"),file.getResultfile());
	}

	/*
	 * Test for void Sql2File(File, String, SqlTableModel)
	 */
	public void testSql2FileFileStringSqlTableModel() {
		Sql2File file=new Sql2File(new File(System.getProperty("java.io.tmpdir")),"sql2class.sql2file",tm);
		file.run();
		comparefiles(new File("test/sql2file/Course01.java"),file.getResultfile());
	}

	public void testSetOptimisticLock() {
		Sql2File file=new Sql2File(new File(System.getProperty("java.io.tmpdir")),"sql2class.sql2file",tm);
		file.setOptimisticLock(true);
		file.run();
		comparefiles(new File("test/sql2file/Course02.java"),file.getResultfile());
	}
	
	public void testPrimaryKey() {
			tm.setPrimaryKey(pk);
			Sql2File file=new Sql2File(new File(System.getProperty("java.io.tmpdir")),"sql2class.sql2file",tm);
			file.run();
			comparefiles(new File("test/sql2file/Course03.java"),file.getResultfile());
		}
		
	public void testDoublePrimaryKey() {
    	tm.setPrimaryKey(pk);
    	pk.getColumns().add((ColumnModel) tm.getColumns().get(1));
    	Sql2File file=new Sql2File(new File(System.getProperty("java.io.tmpdir")),"sql2class.sql2file",tm);
    	file.run();
    	comparefiles(new File("test/sql2file/Course04.java"),file.getResultfile());
	}
	
	public void testTrimValues() {
		Sql2File file=new Sql2File(new File(System.getProperty("java.io.tmpdir")),"sql2class.sql2file",tm);
		file.setTrimValue(true);
		file.run();
		comparefiles(new File("test/sql2file/Course05.java"),file.getResultfile());
	}
    
}
